#!/usr/local/bin/ruby

print "Content-type: text/html\n\n\n"

require "../config.rb"
require "cgi-lib"
require "yaml"

OUTPUT_FILE=CONFIG_FILE

def load_config
	@configuration = {}
	config = config_flatten(File.open(CONFIG_FILE) {|f| YAML.load(f) })
	config.each_with_index {|h, i|
		h.reject! {|k, v| /\A[A-Z]/ !~ k }
		uri = h['URI']
		if @configuration.include? uri
			@configuration[uri].update h
			config[i] = nil
		else
			@configuration[uri] = h
		end
	}
	config.compact!
	config
end

def config_flatten(arr, default={})
	result = []
	arr.each {|elt|
		case elt
		when Hash
			if elt.include? 'URI'
				result << default.dup.update(elt)
			else
				default = default.dup.update(elt)
			end
		when Array
			result.concat config_flatten(elt, default)
		when String
			result << default.dup.update({'URI'=>elt})
		end
	}
	result
end


puts <<EOF;
<HTML>
      <BODY onload="setTimeout(&quot;location.href='#{EDIT_HTML}'&quot;,1000*3)">
EOF


input = CGI.new

oldURI              = input["oldURI"]
newURI              = input["newURI"]
newLinkURI          = input["newLinkURI"]
newTitle            = input["newTitle"]
newIgnorePath       = input["newIgnorePath"]
newIgnoreClass      = input["newIgnoreClass"]
newCategory         = input["newCategory"]
createNewCategory   = input["createNewCategory"]

conf=load_config




conf.each do |c|
	if c["URI"]==oldURI
		if newURI!=oldURI && newURI!="" && newURI!=nil
			c["URI"]=newURI
			puts "URI:"+newURI+"<BR>"
		end
		if c["LinkURI"]!=newLinkURI && newLinkURI!="" && newLinkURI!=nil
			c["LinkURI"]=newLinkURI
			puts "linkURI:"+newLinkURI+"<BR>"
	  end
		if c["Title"]!=newTitle && newTitle!=""
	    c["Title"]=newTitle	
			puts "Title:"+newTitle+"<BR>"
  	end
    if c["IgnorePath"]!=newIgnorePath && newIgnorePath!="" && newIgnorePath!=nil
			c["IgnorePath"]=newIgnorePath
			puts "IgnorePath:"+newIgnorePath+"<BR>"
		end
		if c["IgnoreClass"]!=newIgnoreClass && newIgnoreClass!="" && newIgnoreClass!=nil
			c["IgnoreClass"]=newIgnoreClass
			puts "IgnoreClass:"+newIgnoreClass+"<BR>"
		end
		if c["Category"]!=newCategory && newCategory!="" && newCategory!=nil
			c["Category"]=newCategory
			puts "Category:"+newCategory+"<BR>"
		end
		if c["Category"]!=createNewCategory && createNewCategory!="" && createNewCategory!=nil
			c["Category"]=createNewCategory
			puts "Category:"+createNewCategory+"<BR>"
		end
	end
end

puts "<HR>"

fo=open(OUTPUT_FILE,'w')
fo.puts conf.to_yaml
fo.close


puts <<EOF;
3äۤɤȼưŪޤʤ<A HREF="#{EDIT_HTML}"></A>򥯥åƤ
</BODY>
</HTML>
EOF
